unit hiGMouseHook;

interface

uses Windows, Messages, Kol, Share, Debug;

type
  ThiGMouseHook = class(TDebug)
   private
     FHandle,
     FMouseX,
     FMouseY: integer;  
   public
     _event_onMouseMove,
     _event_onMouseUp,
     _event_onMouseDown,
     _event_onMouseWhell: THI_Event;
     constructor Create;     
     destructor Destroy; override;
 end;

implementation

type
  TMouseMoveHook = record
    case Integer of
    0: (Hook: HHOOK);
    1: (Timer: THandle);
  end;

  PMsLLHookStruct = ^TMsLLHookStruct;
  tagMSLLHOOKSTRUCT = packed record
    pt: TPoint;
    mouseData: DWORD;
    flags: DWORD;
    time: DWORD;
    dwExtraInfo: PDWORD;
  end;
  TMsLLHookStruct = tagMSLLHOOKSTRUCT;

var
  MouseMoveHook: TMouseMoveHook;
  sClass: LongInt; 

function LowLevelMouseProc(nCode: Integer; WParam: WPARAM; LParam: LPARAM): LRESULT; stdcall;
var
  dh, dx, dy, dd: TData;
  sHandle: integer;
  sMouseX, sMouseY: Integer;
begin
  Result := CallNextHookEx(MouseMoveHook.Hook, nCode, WParam, LParam);
  sHandle := WindowFromPoint(PMsLLHookStruct(LParam)^.pt);
  sMouseX := PMsLLHookStruct(LParam)^.pt.X;
  sMouseY := PMsLLHookStruct(LParam)^.pt.Y;  
  ThiGMouseHook(sClass).FHandle := sHandle;
  ThiGMouseHook(sClass).FMouseX := sMouseX;
  ThiGMouseHook(sClass).FMouseY := sMouseY;    
  
  dtInteger(dh, sHandle);

  Case WParam of 
    WM_MOUSEMOVE:
    begin
      dtInteger(dx, sMouseX);
      dtInteger(dy, sMouseY);
      dx.ldata := @dy;
      dy.ldata := @dh;  
      _hi_onEvent_(ThiGMouseHook(sClass)._event_onMouseMove, dx);
      exit;
    end;
    WM_LBUTTONUP:
    begin
      dtInteger(dd, 0);
      dd.ldata := @dh;
      _hi_onEvent_(ThiGMouseHook(sClass)._event_onMouseUp, dd);
    end;  
    WM_RBUTTONUP:
    begin
      dtInteger(dd, 1);
      dd.ldata := @dh;
      _hi_onEvent_(ThiGMouseHook(sClass)._event_onMouseUp, dd);
    end;  
    WM_MBUTTONUP:
    begin
      dtInteger(dd, 2);
      dd.ldata := @dh;
      _hi_onEvent_(ThiGMouseHook(sClass)._event_onMouseUp, dd);
    end;  
    WM_LBUTTONDOWN:
    begin
     dtInteger(dd, 0);
     dd.ldata := @dh;
     _hi_onEvent_(ThiGMouseHook(sClass)._event_onMouseDown, dd);
    end;  
    WM_RBUTTONDOWN:
    begin
      dtInteger(dd, 1);
      dd.ldata := @dh;
      _hi_onEvent_(ThiGMouseHook(sClass)._event_onMouseDown, dd);
    end;  
    WM_MBUTTONDOWN:
    begin
      dtInteger(dd, 2);
      dd.ldata := @dh;
      _hi_onEvent_(ThiGMouseHook(sClass)._event_onMouseDown, dd);
    end;  
    WM_MOUSEWHEEL:
    begin
      dtInteger(dd, smallint(PMsLLHookStruct(LParam)^.mouseData shr 16));
      dd.ldata := @dh;
      _hi_onEvent_(ThiGMouseHook(sClass)._event_onMouseWhell, dd);
    end;
  end;
end;

constructor ThiGMouseHook.Create;
const
  WH_MOUSE_LL = 14;
begin
  inherited;
  sClass := LongInt(Self);
  MouseMoveHook.Hook := SetWindowsHookEx(WH_MOUSE_LL, @LowLevelMouseProc, HInstance, 0);
end;

destructor ThiGMouseHook.Destroy;
begin
  UnhookWindowsHookEx(MouseMoveHook.Hook);
  inherited;
end;

end.